// 
// このコードは、https://demo.mescius.jp/diodocs/pdf のサンプルの一部として提供されています。
// © MESCIUS inc. All rights reserved.
// 
using System;
using System.IO;
using System.Drawing;
using GrapeCity.Documents.Pdf;
using GrapeCity.Documents.Text;
using GrapeCity.Documents.Pdf.Annotations;

namespace DsPdfWeb.Demos
{
    // このサンプルでは、テキスト内の特定の位置を示すために使用するキャレット注釈を作成する方法を示します
    public class AddCaretAnnotation
    {
        public int CreatePDF(Stream stream)
        {
            using var fs = File.OpenRead(Path.Combine("Resources", "PDFs", "Wetlands.pdf"));
            var doc = new GcPdfDocument();
            doc.Load(fs);

            foreach (var page in doc.Pages)
            {
                var tm = page.GetTextMap();
                tm.FindText(new FindTextParams("wetlands", false, false), (fp_) =>
                {
                    // 見つかったテキストの近くにキャレット注釈を追加します
                    var r = fp_.Bounds[0].ToRect();
                    var ca = new CaretAnnotation();
                    ca.Page = page;
                    ca.Rect = new RectangleF(r.Left - 8, r.Bottom - 16, 16, 16);
                });
            }
            doc.Save(stream);
            return doc.Pages.Count;
        }
    }
}
